
// first, we need to include the necessary header files
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "stdafx.h"



#include "common/GMLuaModule.h"



GMOD_MODULE( Init, Shutdown );

// The main file for interaction to the LCD
#include "g15-lcd.h"




LUA_FUNCTION( createLCD )
{
	// This gets the first parameter ("hello")
	bool bEmulator = g_Lua->GetBool(1);
	const char* cName = g_Lua->GetString(2);


	createLCD(bEmulator, cName);

	Msg("Logitech LCD Module Loaded\n");
	return 0;
}
LUA_FUNCTION( updateLCD )
{
updateLCD();
return 0;
}
LUA_FUNCTION( settextorigin )
{
	int id = g_Lua->GetNumber(1);
	int x = g_Lua->GetNumber(2);
	int y = g_Lua->GetNumber(3);
	settextorigin(id,x,y);
	return 0;
}
LUA_FUNCTION( settexttext )
{
	int id = g_Lua->GetNumber(1);
	const char* cText = g_Lua->GetString(2);
	settexttext( id, cText );
	return 0;
}


LUA_FUNCTION( addtext )
{
	int id = g_Lua->GetNumber(1);
	bool scrolling = g_Lua->GetBool(2);
	int size = g_Lua->GetNumber(3);
	int align = g_Lua->GetNumber(4);
	int maxlen = g_Lua->GetNumber(5);
	int lines = g_Lua->GetNumber(6);
	addtext( id, scrolling, size, align, maxlen, lines );
	return 0;
}

LUA_FUNCTION( addtextfont )
{
	int id = g_Lua->GetNumber(1);
	bool scrolling = g_Lua->GetBool(2);
	int size = g_Lua->GetNumber(3);
	int align = g_Lua->GetNumber(4);
	int maxlen = g_Lua->GetNumber(5);
	int lines = g_Lua->GetNumber(6);
	const char* font = g_Lua->GetString(7);
	addtextfont( id, scrolling, size, align, maxlen, lines, _T(font));
	return 0;
}

LUA_FUNCTION( settextvis )
{
	int id = g_Lua->GetNumber(1);
	int visible = g_Lua->GetBool(2);
	settextvis( id, visible );
	return 0;
}
LUA_FUNCTION( settextalign )
{
	int id = g_Lua->GetNumber(1);
	int align = g_Lua->GetNumber(2);
	settextalign(id, align);
	return 0;
}
LUA_FUNCTION( isbuttonpressed )
{
	int button = g_Lua->GetNumber(1);
	bool pressed = ezlcd_->ButtonIsPressed(button);
	g_Lua->Push(pressed);
	return 1;
}
LUA_FUNCTION( addpbar )
{
	int id = g_Lua->GetNumber(1);
	int type = g_Lua->GetNumber(2);
	addpbar( id, type );
	return 0;
}
LUA_FUNCTION( setpbarorigin )
{
	int id = g_Lua->GetNumber(1);
	int x = g_Lua->GetNumber(2);
	int y = g_Lua->GetNumber(3);
	setpbarorigin( id, x, y );
	return 0;
}
LUA_FUNCTION( setpbarsize )
{
	int id = g_Lua->GetNumber(1);
	int width = g_Lua->GetNumber(2);
	int height = g_Lua->GetNumber(3);
	setpbarsize( id, width, height );
	return 0;
}
LUA_FUNCTION( setpbarvalue )
{
	int id = g_Lua->GetNumber(1);
	int value = g_Lua->GetNumber(2);
	setpbarvalue( id, value );
	return 0;
}
LUA_FUNCTION( setpbarvis )
{
	int id = g_Lua->GetNumber(1);
	int visible = g_Lua->GetBool(2);
	setpbarvis( id, visible );
	return 0;
}

LUA_FUNCTION( addpage )
{
ezlcd_->AddNewPage();
return 0;
}
LUA_FUNCTION( getpagecount )
{
float pagecount = ezlcd_->GetPageCount();
g_Lua->Push(pagecount);
return 1;
}
LUA_FUNCTION( modifypagenum )
{
int page = g_Lua->GetNumber(1);
ezlcd_->ModifyControlsOnPage(page);
return 0;
}
LUA_FUNCTION( showpagenum )
{
int page = g_Lua->GetNumber(1);
ezlcd_->ShowPage(page);
return 0;
}
LUA_FUNCTION( removepage )
{
int page = g_Lua->GetNumber(1);
ezlcd_->RemovePage(page);
return 0;
}
LUA_FUNCTION( setforeground )
{
bool fore = g_Lua->GetBool(1);
setforeground(fore);
return 0;
}
LUA_FUNCTION( addfbox )
{
int id = g_Lua->GetNumber(1);
int x = g_Lua->GetNumber(2);
int y = g_Lua->GetNumber(3);
int width = g_Lua->GetNumber(4);
int height = g_Lua->GetNumber(5);
addfbox( id, x, y, width, height );
return 0;
}
LUA_FUNCTION( addebox )
{
int id = g_Lua->GetNumber(1);
int x = g_Lua->GetNumber(2);
int y = g_Lua->GetNumber(3);
int width = g_Lua->GetNumber(4);
int height = g_Lua->GetNumber(5);
addebox( id, x, y, width, height );
return 0;
}
LUA_FUNCTION( setboxvis )
{
int id = g_Lua->GetNumber(1);
int visible = g_Lua->GetBool(2);
setboxvis(id,visible);
return 0;
}
LUA_FUNCTION( setboxorigin )
{
int id = g_Lua->GetNumber(1);
int x = g_Lua->GetNumber(2);
int y = g_Lua->GetNumber(3);
setboxorigin( id, x, y );
return 0;
}
LUA_FUNCTION( setboxsize )
{
	int id = g_Lua->GetNumber(1);
	int width = g_Lua->GetNumber(2);
	int height = g_Lua->GetNumber(3);
	setboxsize( id, width, height );
	return 0;
}
LUA_FUNCTION( addpx )
{
int id = g_Lua->GetNumber(1);
int x = g_Lua->GetNumber(2);
int y = g_Lua->GetNumber(3);
addpx( id, x, y );
return 0;
}
LUA_FUNCTION( setpxvis )
{
int id = g_Lua->GetNumber(1);
int visible = g_Lua->GetBool(2);
setpxvis(id,visible);
return 0;
}
LUA_FUNCTION( setpxorigin )
{
int id = g_Lua->GetNumber(1);
int x = g_Lua->GetNumber(2);
int y = g_Lua->GetNumber(3);
setpxorigin( id, x, y );
return 0;
}
LUA_FUNCTION( removetext )
{
int id = g_Lua->GetNumber(1);
removetext( id );
return 0;
}
LUA_FUNCTION( removepbar )
{
int id = g_Lua->GetNumber(1);
removepbar( id );
return 0;
}
LUA_FUNCTION( removebox )
{
int id = g_Lua->GetNumber(1);
removebox( id );
return 0;
}
LUA_FUNCTION( removepx )
{
int id = g_Lua->GetNumber(1);
removepx( id );
return 0;
}
LUA_FUNCTION( setboxfilled )
{
int id = g_Lua->GetNumber(1);
int filled = g_Lua->GetBool(2);
setboxfilled( id, filled );
return 0;
}
LUA_FUNCTION( istextidempty )
{
	int id = g_Lua->GetNumber(1);
	bool empty = istextidempty(id);
	g_Lua->Push(empty);
	return 1;
}
LUA_FUNCTION( ispbaridempty )
{
	int id = g_Lua->GetNumber(1);
	bool empty = ispbaridempty(id);
	g_Lua->Push(empty);
	return 1;
}
LUA_FUNCTION( isboxidempty )
{
	int id = g_Lua->GetNumber(1);
	bool empty = isboxidempty(id);
	g_Lua->Push(empty);
	return 1;
}
LUA_FUNCTION( ispxidempty )
{
	int id = g_Lua->GetNumber(1);
	bool empty = ispxidempty(id);
	g_Lua->Push(empty);
	return 1;
}
LUA_FUNCTION( setdebug )
{
	setdebug();
	return 0;
}
LUA_FUNCTION( settextinvert )
{
	int id = g_Lua->GetNumber(1);
	bool invert = ispxidempty(id);
//	settextinvert(id,invert);
	return 1;
}
int Init( void )
{

	// ets make a global table filled with functions (a module)
	g_Lua->NewGlobalTable( "g15" );



	ILuaObject* table = g_Lua->GetGlobal( "g15" );


	// Functions
	// Main
	table->SetMember( "createLCD", createLCD );
	table->SetMember( "updateLCD", updateLCD );
	table->SetMember( "setforeground", setforeground );
	table->SetMember( "setdebug", setdebug );

	// Text
	table->SetMember( "settextorigin", settextorigin );
	table->SetMember( "settexttext", settexttext);
	table->SetMember( "addtext", addtext);
	table->SetMember( "addtextfont", addtextfont);
	table->SetMember( "settextalign", settextalign);
	table->SetMember( "settextvis", settextvis);
	table->SetMember( "removetext", removetext);
	table->SetMember( "istextidempty", istextidempty);
	table->SetMember( "settextinvert", settextinvert);

	// Buttons
	table->SetMember( "isbuttonpressed", isbuttonpressed);

	// Progress Bars
	table->SetMember( "addpbar", addpbar);
	table->SetMember( "setpbarorigin", setpbarorigin);
	table->SetMember( "setpbarsize", setpbarsize);
	table->SetMember( "setpbarvalue", setpbarvalue);
	table->SetMember( "setpbarvis", setpbarvis);
	table->SetMember( "removepbar", removepbar);
	table->SetMember( "ispbaridempty", ispbaridempty);

	// Pages
	table->SetMember( "addpage", addpage);
	table->SetMember( "getpagecount", getpagecount);
	table->SetMember( "modifypagenum", modifypagenum);
	table->SetMember( "showpagenum", showpagenum);
	table->SetMember( "removepage", removepage);

	// Boxes
	table->SetMember( "addfbox", addfbox );
	table->SetMember( "addebox", addebox );
	table->SetMember( "setboxvis", setboxvis );
	table->SetMember( "setboxorigin", setboxorigin );
	table->SetMember( "setboxsize", setboxsize );
	table->SetMember( "removebox", removebox );
	table->SetMember( "setboxfilled", setboxfilled );
	table->SetMember( "isboxidempty", isboxidempty);

	// Pixels
	table->SetMember( "addpx", addpx );
	table->SetMember( "setpxvis", setpxvis );
	table->SetMember( "setpxorigin", setpxorigin );
	table->SetMember( "removepx", removepx );
	table->SetMember( "ispxidempty", ispxidempty);


	// We're not deleting the table here - we're deleting the reference to it.
	// If you don't do this you're leaking memory.
	SAFE_UNREF( table );
	
	return 0;
}


int Shutdown( void )
{
	killLCD();
	return 0;
}

